// PIC24EP256MC202
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <xc.h>
#include <PPS.h>                   // Pin Re-Mapping peripheral library
// __delay_ms/__delay_usׂ̈ɕKv
#define FCY 60000000UL             // Fosc/2(60MIPS)
#include <libpic30.h>

#include "skUARTlib.h"


// RtBM[V̐ݒ
// FICD
#pragma config ICS    = PGD1       // In-Circuit Debuggers̒ʐM`ĺiPGEC1PGED1ŒʐM܂)
#pragma config JTAGEN = OFF        // JTAG ͎gpȂ
// FPOR
#pragma config ALTI2C1 = ON        // I2C1ŎgpśAASDA1/ASCL1gp
#pragma config ALTI2C2 = ON        // I2C2ŎgpśAASDA2/ASCL2gp
#pragma config WDTWIN  = WIN25     // EIb`hbO25%EChËƂ
// FWDT
#pragma config WDTPOST = PS32768   // Watchdog Timer Postscaler bits (1:32,768)
#pragma config WDTPRE  = PR128     // Watchdog Timer Prescaler bit (1:128)
#pragma config PLLKEN  = ON        // PLLbN܂őҋ@APLLNbN֐؂芷܂
#pragma config WINDIS  = OFF       // EIb`hbOɃEChE͎gȂ
#pragma config FWDTEN  = OFF       // EIb`hbO̗L/"SWDTEN"rbgōs
// FOSC
#pragma config POSCMD   = NONE     // OIV[^̓샂[h̑I (OIV[^͎gȂ)
#pragma config OSCIOFNC = ON       // OSC2s@\̑I (OSC2s̓fW^I/OƂ)
#pragma config IOL1WAY  = OFF      // Ӌ@̃st͉xłύXolɋ
#pragma config FCKSM    = CSDCMD   // NbN̊ĎNbNؑւ͂Ȃ
// FOSCSEL
#pragma config FNOSC   = FRCPLL    // IV[^PLL삳
#pragma config PWMLOCK = OFF       // PWMbNrbg(bNV[PXŏ݉\)
#pragma config IESO    = OFF       // FosĉQiK؂ւł̋N͂Ȃ
// FGS
#pragma config GWRP = OFF          // General Segment Write-Protect bit (General Segment may be written)
#pragma config GCP  = OFF          // General Segment Code-Protect bit (General Segment Code protect is Disabled)

/*******************************************************************************
*  C̏                                                                *
*******************************************************************************/
int main(void)
{
     char dt[8] ;

     ///////////////////////////////////////////////////////////////////////////
     // MCȔlݒs                                             //
     ///////////////////////////////////////////////////////////////////////////
     _SWDTEN = 0 ;                 // EIb`hbO͖
     // VXeNbN̐ݒ(Fosc=120MHz FCY=60MHz/60MIPS)
     // Fosc=FRC*(M/(N1*N2))  M=PLLDIV+2  N1=PLLPRE+2  N2=2*(PLLPOST+1)
     // Fosc=7.37*(65/(2*2))=119.7625(120MHz)  FCY=120/2=60MIPS
     _FRCDIV  = 0b000 ;            //  FRC|XgXP[(ȂF7.37MHz)
     _PLLPRE  = 0b00000 ;          // PLL̓̓vXP[[N1=2](QF7.37/2=3.685MHz)
     _PLLDIV  = 63 ;               // PLL̃tB[hobNl[M=65]
     _PLLPOST = 0b00 ;             // PLL̏o̓|XgXP[[N2=2](Ȃ)
     // Wait for PLL to lock
     while (OSCCONbits.LOCK!= 1) ;
     // I/O̐ݒ
     ANSELA = 0b0000000000000000 ; // AN0,1AiO͎gpȂAfW^I/OɊ
     ANSELB = 0b0000000000000000 ; // AN2-5AiO͎gpȂAfW^I/OɊ
     TRISA  = 0b0000000000000000 ; // RA0-RA4Sďo͂ɐݒA1œ 0ŏo
     TRISB  = 0b0001000000000000 ; // RB12͓́Ȃ͏o͂ɐݒ
     PORTA  = 0b0000000000000000 ; // o̓s̏(SLOWɂ)
     PORTB  = 0b0000000000000000 ; // o̓s̏(SLOWɂ)
     // S̊荞݂̋ݒ
     _IPL     = 0 ;                // CPŮݗD惌xݒ(D惌xOȏ)
     _GIE     = 1 ;                // S荞ݏ

     ///////////////////////////////////////////////////////////////////////////
     // Ӌ@\̃sts                                      //
     ///////////////////////////////////////////////////////////////////////////
     // UART1@\t
     PPSUnLock ;
     iPPSInput(IN_FN_PPS_U1RX,IN_PIN_PPS_RPI44) ;   // RB12(RX1)
     iPPSOutput(OUT_PIN_PPS_RP43,OUT_FN_PPS_U1TX) ; // RB11(TX1)
     PPSLock ;

     ///////////////////////////////////////////////////////////////////////////
     // Ӌ@\̏ݒs                                          //
     ///////////////////////////////////////////////////////////////////////////
     // UART1̏s(WbitnoParity1StopnoFlow 9600bps)
     InitUART(0, 0, 9600) ;

     ///////////////////////////////////////////////////////////////////////////
     // C̃[v                                                    //
     ///////////////////////////////////////////////////////////////////////////
     dt[0] = 0x00 ;
     dt[1] = 0x0d ;            // CR(\r)
     dt[2] = 0x0a ;            // LF(\n)

     while(1) {
          if (UART_Available() != 0) {
               // Mf[^ɉsR[htĂ̂܂ܕԂ
               dt[0] = UART_Read() ;    // PoCgf[^M
               UART_Send(dt,3) ;        // RoCgf[^𑗐M
          }
     }
}
